.\"
.\" netname.man,v 1.7 1997/02/10 15:50:18 kim Exp
.\"
.TH NETNAME 1 "23 September 1996" "TAC 1.6"
.SH NAME 
.B netname
- Return the canonical network name of a host
.SH SYNOPSIS
.B netname
[
.B \-d
]
[
.B \-v
]
[
.I host
]
.br
.SH DESCRIPTION
.I netname
returns the canonical network name of the given host
on the standard output.  If no host is given, the name
of the local machine is used.
.PP
If  the
.B \-d
option is specified, then only the domain part of the
canonical network name is returned (i.e. the part after
the first dot in the name).
.PP
A top-level name is its own domain (i.e. names without
dots are considered both the canonical network name and
the domain).
.PP
To check the version of the binary use the
.B \-v
option.
.SH EXAMPLES
HOST=`netname`
.br
setenv HOST `netname`
.SH RETURN VALUE
.TP 3
.B 0
Successful completion.
.TP
.B 1
Cannot resolve network name.
.TP
.B 2
Cannot get the name of the local machine from
.IR uname (2).
.SH BUGS
No known bugs.
.SH AUTHOR
Kimmo Suominen <kim@tac.nyc.ny.us>
.SH SEE ALSO
.IR hostname (1),
.IR nodename (1),
.IR uname (1),
.IR uname (2),
.IR gethostbyname (3)
